#ifndef TIMER_H
#define TIMER_H
/*****************************************************************************
* TIMER.H																						  *
*																									  *
* Timer class based on the 54ms realtime clock.										  *

(c) Copyright 1996, Zonn Moore.  All rights reserved.
*****************************************************************************/
#ifndef ZSTDDEF_H
#include	"zstddef.h"
#endif

#define	TIME1SEC		18				// approximate ticks in 1 second

class t_timer
{
private:
	int	timer;						// time at start of a timer

public:
	void		wait( int time);		// just wait for 'time'
	void		start( void);			// start a timer
	t_logic	timeout( int time);	// true if 'time' has passed since 'start()'
};
	
class t_timer_ms
{
private:
	long			timer;					// time at start of a timer
	static int	initFlag;				// indicate 8253 has been initialized

public:
	t_timer_ms( void);					// calls 'init_8253()' if needed
	~t_timer_ms( void);					// calls 'restore_8253()' if last one out

	void		start( void);				// start a timer
	t_logic	timeout( long time);		// true if 'time' has passed since 'start()'
	t_logic	ticks( long ticks);		// true if 'ticks' has passed since 'start()'
};

#endif
