;----------------------------------------------------------------------------;
; TIMER.ASM                                                                  ;
;                                                                            ;
; (c) Copyright 1994, Zonn Moore.  All rights reserved.                      ;
;----------------------------------------------------------------------------;
		IDEAL
		include	"bcmacros.inc"

segment		ABS40	at 00040h
		org	0006Ch
timer_low	dw	?	; BIOS's tick timer
		ends

		CODESEG
;----------------------------------------------------------------------------;
; waittimer( ticks)							     ;
;									     ;
; Call BIOS interrupt 1Ah, and wait for 'tick' number of ticks.		     ;
;									     ;
;    Where:								     ;
; 	ticks	= Number of real time ticks to wait before returning.	     ;
;----------------------------------------------------------------------------;
public		_waittimer
proc		_waittimer	c

		arg	ticks:WORD

		mov	ax,ABS40	; point to bios's data segment
		mov	es,ax
		assume	es:ABS40
		mov	bx,Offset timer_low
		mov	ax,[es:bx]	; get ticker
		add	ax,[ticks]	; get ending value
dtim1:		cmp	ax,[es:bx]	; wait for ending value
		jne	dtim1
		sub	ax,ax		; return nothing
		ret

		endp

;----------------------------------------------------------------------------;
; int gettimer()							     ;
;									     ;
; Get current timer value.						     ;
;----------------------------------------------------------------------------;
public		_gettimer
proc		_gettimer	c

		mov	ax,ABS40		; point to BIOS's segment
		mov	es,ax			; set segment pointer
		mov	ax,[es:timer_low]	; get current tick counter
		ret

		endp

;----------------------------------------------------------------------------;
; int testtimer( tval, time)						     ;
;									     ;
; Test to see if 'time' amount of ticks have passed since 'tval' was	     ;
; read.									     ;
;									     ;
;   Returns:								     ;
;      True  - If timer has timed out.					     ;
;      False - If timer hasn't timed out.				     ;
;----------------------------------------------------------------------------;
public		_testtimer
proc		_testtimer	c

		arg	tval:WORD,time:WORD

		mov	ax,ABS40	; point to BIOS's segment
		mov	es,ax		; set segment register
		mov	ax,[es:timer_low] ; get time
		sub	ax,[tval]
		cmp	ax,[time]	; is it greater than time
		mov	ax,0		; (indicate false)
		jl	tst1		; no, then false
		inc	ax		; else, return true
tst1:		ret

		endp
		end
